package me.Demon.DemonNeverLag;

import me.Demon.DemonNeverLag.ClearEntity.AntiChicken;
import me.Demon.DemonNeverLag.ClearEntity.AntiCow;
import me.Demon.DemonNeverLag.ClearEntity.AntiEntity_Nether;
import me.Demon.DemonNeverLag.ClearEntity.AntiSheep;
import me.Demon.DemonNeverLag.listener.*;
import me.Demon.DemonNeverLag.task.ClearItem;
import me.Demon.DemonNeverLag.util.Config;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static String prefix = "§7[§6战争领域§7] §f";

    @Override
    public void onEnable() {
        plugin = this;
        Config.init(loadConfig());
        Bukkit.getServer().getPluginManager().registerEvents(new AntiEntity_Nether(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiSheep(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiCow(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiChicken(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiShuaDongXi(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new FluidLimit(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ArrowRemover(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiEnderPearl(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ProtectFarm(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiExplode(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiCrashSign(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiChatLimit(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiNoRain(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new NoSpawnChunk(), plugin);
        // Bukkit.getServer().getPluginManager().registerEvents(new SpawnRate(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new VoidTp(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new AntiItemMerge(), plugin);
        if(Config.ClearItem_butt) {
            int clear_time = Config.ClearItem_Delay;
            getServer().getScheduler().scheduleSyncRepeatingTask(this, new Runnable() {
                public void run() {
                    ClearItem.clean_run();
                }
            }, clear_time * 20L, clear_time * 20L);
            getServer().getScheduler().scheduleSyncRepeatingTask(this, new Runnable() {
                public void run() {
                    ClearItem.domessage();
                }
            }, 20L, 20L);
        }
    }

    @Override
    public void onDisable() {

    }

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("neverlag") && sender.isOp()) {
            if(args.length == 1 && args[0].equalsIgnoreCase("clearitem")){
                ClearItem.clean_run();
                sender.sendMessage(prefix+"垃圾清理启动成功.");
            }
        }
        return false;
    }
    public static boolean itemIsNull(ItemStack item){
        return item == null || item.getType() == Material.AIR;
    }
    public static boolean itemIsLore(ItemStack item){
        return item.getItemMeta().getLore() == null;
    }

    public YamlConfiguration loadConfig() {
        saveDefaultConfig();
        YamlConfiguration config = new YamlConfiguration();
        try {
            config.load(new InputStreamReader(new FileInputStream(new File(getDataFolder(), "config.yml")), StandardCharsets.UTF_8));
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
        return config;
    }
}
